/*--------------------------------------------------------------
|       Logique de Relais UHF avec voie VHF Simplex
|       
|                     Version 2.16
|                autorise ou non la DTMF      
|                    F4GEN / F8KGZ
--------------------------------------------------------------*/
#include <LiquidCrystal.h>//charge la librairie LiquidCrystal
LiquidCrystal lcd_A(51,49,41,47,43,45);/* déclare un afficheur lcd, 
l'initialise en mode 4 bits et définit les broches de l'arduino
utilisées pour relier les broches RS,E,D4,D5,D6,D7 de ce lcd.*/
LiquidCrystal lcd_B(51,53,41,47,43,45);

String indicatif_relais="F1ZHQ";
String balise_relais_court="F1ZHQ JN38BQ VA";
String balise_relais_long="F1ZHQ RELAIS INTERCOM DE NANCY JN38BQ 73";

boolean val_SQL_UHF = false; // false=>masse true=>+5V
boolean val_SQL_VHF = false; // false=>masse true=>+5V
boolean val_TONE_1750 = false; // false=>masse true=>+5V


int TimeoutRelais=20; //temps en secondes pour l'arret du relais si pas de QSO
int TimeoutVHF=20; //temps en secondes pour reinitailiser la frequence VHF
int vitesse=20; // vitesse de la CW
int antibavard1=180; //temps anti-bavard 1 en secondes
int antibavard2=300; //temps anti-bavard 2 en secondes
long BaliseRelais=600; // delai en secondes entre l'envoi de 2 balises
int nb_balise=2; //  nombre de balises courtes avant l'envoi de la balise longue
boolean Int_Balise = false; //autorisation interuption balise au déclenchement du relais

int PTT_UHF = 12;  // Sortie Commande PTT UHF
int Led_PTT_UHF = 33;  // Sortie Led PTT UHF
int PTT_VHF = 11;  // Sortie Commande PTT VHF
int Led_PTT_VHF = 32;  // Sortie Led PTT VHF
int SQL_UHF = 3;  // Entree Squelch UHF
int PTT_APRS = 10;  // Sortie Commande PTT VHF
int Led_SQL_UHF = 31;  // Led Squelch UHF
int SQL_VHF = 2;  // Entree Squelch VHF
int Led_SQL_VHF = 30;  // Led Squelch VHF
int TONE_1750 = 6;  // Entree presence 1750Hz
int TONE_SQL = 4;  // Entree declechement par 1750 ou Squelch

int SortieCW = 13; // permet de voir la CW sur la led de l'arduino
int SortieBuzzer = 5; // Sortie BF pour la CW

boolean PTT_UHF_ok = true;
boolean PTT_VHF_ok = true;
boolean BaliseCW= true; //autorise la CW
boolean LCD = true; // Afficheur LCD Présent

int BF_UHF_in_4066 = 22;
int BF_VHF_in_4066 = 23;
int BF_APRS_in_4066 = 24;
int BF_APRS_out_4066 = 25;
int BF_Synthe_out_4066 = 26;
int BF_UHF_out_4066 = 27;
int BF_VHF_out_4066 = 28;


//decodeur DTMF
int DTMF_StD = 21;
int DTMF_Q1 = 17;
int DTMF_Q2 = 16;
int DTMF_Q3 = 15;
int DTMF_Q4 = 14;
int val_dtmf;
String code_DTMF[6];
String Freq_DTMF;
int compteur_DTMF = 0;
boolean erreur_DTMF = false;
boolean valide_DTMF = true;

String txttouche="";
String lettre="";
String lettrecw="";
String etat_PTT_UHF="Off";
String etat_PTT_VHF="Off";
String etat_SQL_UHF="Off";
String etat_SQL_VHF="Off";
String etat_TONE_1750="1750Hz Off";

int timeout_vhf_Event;

int antibavardsec;
boolean relais_ok;

int compt_balise=0;
int compt=0;
boolean volatile etat_relais=false; 
boolean bip_antibavard=false;
boolean relais_en_service=false;

int Mem_VHF = 7;
int Mem_Down = 8;
int Mem_Up = 9;
int Mem_Start = 12; //memoire par defaut
int Aff_Mem = 1;

String Memoire_VHF[60];
String Simple_Duplex[60];
int compt_mem;



unsigned long BaliseTimer; 
boolean BaliseTimerStart;

unsigned long TimeOutQSO; 
boolean TimeOutQSOStart;

unsigned long timeout_vhf; // Timer pour la frequence VHF
boolean timeout_vhfStart;

void setup(){


  //les memoires programmées dans la Voie VHF
  /*
  Memoire_VHF[1]="4800";
  Memoire_VHF[2]="5200";
  Memoire_VHF[3]="5212";
  Memoire_VHF[4]="5225";
  Memoire_VHF[5]="5237";
  Memoire_VHF[6]="5262";
  Memoire_VHF[7]="5275";
  Memoire_VHF[8]="5287";
  Memoire_VHF[9]="5500";
  Memoire_VHF[10]="5612";
  Memoire_VHF[11]="5625";
  Memoire_VHF[12]="5637";//->> Milieu Memoire
  Memoire_VHF[13]="5650";
  Memoire_VHF[14]="5662";
  Memoire_VHF[15]="5675";
  Memoire_VHF[16]="5687";
  Memoire_VHF[17]="5700";
  Memoire_VHF[18]="5712";
  Memoire_VHF[19]="5725";
  Memoire_VHF[20]="5737";
  Memoire_VHF[21]="5750";
  Memoire_VHF[22]="5762";
  Memoire_VHF[23]="5775";
  Memoire_VHF[24]="5787";
  */
  
  Memoire_VHF[1]="4800";
  Simple_Duplex[1]="aprs";
  Memoire_VHF[2]="5700";
  Simple_Duplex[2]="relais";
  Memoire_VHF[3]="5712";
  Simple_Duplex[3]="relais";
  Memoire_VHF[4]="5612";
  Simple_Duplex[4]="relais";
  Memoire_VHF[5]="5287";
  Simple_Duplex[5]="simplex";
  Memoire_VHF[6]="5262";
  Simple_Duplex[6]="simplex";
  Memoire_VHF[7]="5237";
  Simple_Duplex[7]="simplex";
  Memoire_VHF[8]="5212";
  Simple_Duplex[8]="simplex";
  Memoire_VHF[9]="5500";
  Simple_Duplex[9]="simplex";
  Memoire_VHF[10]="5275";
  Simple_Duplex[10]="simplex";
  Memoire_VHF[11]="5225";
  Simple_Duplex[11]="simplex";
  Memoire_VHF[12]="5300";//->> Milieu Memoire 
  Simple_Duplex[12]="simplex";
  Memoire_VHF[13]="5637";
  Simple_Duplex[13]="relais";
  Memoire_VHF[14]="5675";
  Simple_Duplex[14]="relais";
  Memoire_VHF[15]="5662";
  Simple_Duplex[15]="relais";
  Memoire_VHF[16]="5687";
  Simple_Duplex[16]="relais";
  Memoire_VHF[17]="5625";
  Simple_Duplex[17]="relais";
  Memoire_VHF[18]="5650";
  Simple_Duplex[18]="relais";
  Memoire_VHF[19]="5725";
  Simple_Duplex[19]="relais";
  Memoire_VHF[20]="5737";
  Simple_Duplex[20]="relais";
  Memoire_VHF[21]="5750";
  Simple_Duplex[21]="relais";
  Memoire_VHF[22]="5762";
  Simple_Duplex[22]="relais";
  Memoire_VHF[23]="5775";
  Simple_Duplex[23]="relais";
  Memoire_VHF[24]="5787"; 
  Simple_Duplex[24]="relais";
  
  // codes reserves aux SysOps
  Memoire_VHF[50]="XXXX"; //desactive la voie VHF
  Memoire_VHF[51]="XXXX"; //desactive la voie UHF
  Memoire_VHF[52]="XXXX"; //active la voie VHF
  Memoire_VHF[53]="XXXX"; //active la voie UHF
  Memoire_VHF[54]="XXXX"; //active la CW
  Memoire_VHF[55]="XXXX"; //desactive la CW
  Memoire_VHF[56]="XXXX"; //active la DTMF
  Memoire_VHF[57]="XXXX"; //desactive la DTMF
  
// affichage texte sur l'afficheur
if(LCD==true){
  lcd_A.begin(40,2);
  lcd_A.print(indicatif_relais+": Decl:                            ");
  lcd_A.setCursor(0,1);
  lcd_A.print("UHF: PTT:Off SQL:Off                    ");
  lcd_B.begin(40,2);
  lcd_B.print("VHF: PTT:Off SQL:Off                    ");
  lcd_B.setCursor(0,1);
  lcd_B.print("Anti-bavard:                            ");
} 
// paramétrage entrées/ sorties de l'arduino  
   pinMode(PTT_UHF, OUTPUT);
   pinMode(PTT_VHF, OUTPUT);
   pinMode(Led_PTT_UHF, OUTPUT);
   digitalWrite(Led_PTT_UHF, HIGH);
   pinMode(Led_PTT_VHF, OUTPUT);
   pinMode(PTT_APRS, INPUT);
   digitalWrite(PTT_APRS, HIGH); //resistance au +
   digitalWrite(Led_PTT_VHF, HIGH);
   pinMode(SortieCW, OUTPUT);
   pinMode(SortieBuzzer, OUTPUT);
   pinMode(SQL_UHF, INPUT);
   digitalWrite(SQL_UHF, HIGH); //resistance au +
   pinMode(Led_SQL_UHF, OUTPUT);
   digitalWrite(Led_SQL_UHF, HIGH);
   pinMode(SQL_VHF, INPUT);
   digitalWrite(SQL_VHF, HIGH); //resistance au +
   pinMode(Led_SQL_VHF, OUTPUT);
   digitalWrite(Led_SQL_VHF, HIGH);
   pinMode(TONE_1750, INPUT);
   digitalWrite(TONE_1750, HIGH); //resistance au +
   pinMode(TONE_SQL, INPUT);
   digitalWrite(TONE_SQL, HIGH); //resistance au +

   
   pinMode(BF_UHF_in_4066, OUTPUT);
   pinMode(BF_VHF_in_4066, OUTPUT);
   pinMode(BF_APRS_in_4066, OUTPUT);
   pinMode(BF_APRS_out_4066, OUTPUT);
   pinMode(BF_Synthe_out_4066, OUTPUT);
   pinMode(BF_UHF_out_4066, OUTPUT);
   pinMode(BF_VHF_out_4066, OUTPUT);
   digitalWrite(BF_UHF_in_4066, HIGH);
   digitalWrite(BF_VHF_in_4066, LOW);
   digitalWrite(BF_APRS_in_4066, HIGH);
   digitalWrite(BF_APRS_out_4066, HIGH);
   digitalWrite(BF_Synthe_out_4066, LOW);
   digitalWrite(BF_UHF_out_4066, HIGH);
   digitalWrite(BF_VHF_out_4066, LOW);
   
   pinMode(DTMF_StD, INPUT);
   pinMode(DTMF_Q1, INPUT);
   pinMode(DTMF_Q2, INPUT);
   pinMode(DTMF_Q3, INPUT);
   pinMode(DTMF_Q4, INPUT);
   
   pinMode(Mem_VHF, OUTPUT);
   pinMode(Mem_Down, OUTPUT);
   pinMode(Mem_Up, OUTPUT);
   
   digitalWrite(Mem_VHF,HIGH); // position sur la frequence par defaut
   delay (200);
   digitalWrite(Mem_VHF,LOW);
   delay (200);
   // positionne sur la frequence APRS
   compt_mem =Mem_Start-2;
     for (int i=0; i <= abs(compt_mem); i++){ 
       digitalWrite(Mem_Down,HIGH); // Appui sur la touche DOWN
       delay (200);
       digitalWrite(Mem_Down,LOW);  
        delay (200);   
     }
	 
	 
	BaliseTimerStart=true; //demarrage de la balise
	BaliseTimer=millis();
	TimeOutQSOStart=false;
        timeout_vhfStart=false;

   AutoriseInt(); //mise en service des interruptions
}
void loop(){

  if (BaliseTimer>millis()){BaliseTimer=millis();} // apres les 50 jours millis revient à 0, on remet à jour BaliseTimer
  if (BaliseTimerStart==false){BaliseTimer=millis();}
  if (millis()-BaliseTimer>BaliseRelais*1000){
	EnvoiBalise(); ///envoi la balise
	BaliseTimer=millis(); // Remise à 0 de la balise
	}
  if (timeout_vhf>millis()){timeout_vhf=millis();} // apres les 50 jours millis revient à 0, on remet à jour TimeOutQSO
  if (timeout_vhfStart==false){timeout_vhf=millis();}
  if (millis()-timeout_vhf>TimeoutVHF*1000){
	InitVHF(); // VHF en APRS
	}
  if (TimeOutQSO>millis()){TimeOutQSO=millis();} // apres les 50 jours millis revient à 0, on remet à jour TimeOutQSO
  if (TimeOutQSOStart==false){TimeOutQSO=millis();}
  if (millis()-TimeOutQSO>TimeoutRelais*1000){
	StopRelais(); // Stop le relais
	}

	
  digitalWrite(Led_SQL_UHF,digitalRead(SQL_UHF));
  digitalWrite(Led_SQL_VHF,digitalRead(SQL_VHF));
  
if (Aff_Mem==1){
  if (PTT_VHF_ok){
    digitalWrite(PTT_VHF,!digitalRead(PTT_APRS));
    digitalWrite(Led_PTT_VHF,digitalRead(PTT_APRS)); 
  }
}
  
  if (etat_relais==true){ // demande de mise en service relais
        delay(300);
        if ((digitalRead(SQL_VHF)==val_SQL_VHF)or(digitalRead(SQL_UHF)==val_SQL_UHF)){ // si la porteuse est toujours présente
          if ((digitalRead(TONE_1750)==val_TONE_1750) and (!digitalRead(TONE_SQL))){ // si déclenchement par 1750Hz et 1750Hz présent
            if(digitalRead(SQL_UHF)==val_SQL_UHF){ // si 1750 sur voie UHF
              PTT_VHF_ON(); //activation PTT VHF pour envoyer le 1750 aussi sur la voie VHF
                  compt=0;
                  while (digitalRead(SQL_UHF)==val_SQL_UHF){
                    //================> detection blocage squelch pour sortir de la boucle
                    delay (1000);
                    compt++;
                    if (compt>=10){break;}
                    afficheur();
                    }
                    digitalWrite(PTT_VHF, LOW); //désactivation PTT VHF 
                    digitalWrite(Led_PTT_VHF, HIGH); //désactivation Led PTT VHF 
            }
            Start_Relais(); // demarrage du relais
          }
          
          if (digitalRead(TONE_SQL)){ //si declenchement par squelch
           Start_Relais();   // demarrage du relais
          }
   }else{
      etat_relais=false;  // si apres les 300ms, il n'y a plus de porteuse, annulation de la demande de mise en service du relais
   }
 }
   
  if (digitalRead(PTT_UHF)){ // si relais est en service
  //======================= Fonctionnement avec une frequence Simplex en VHF =======================================
    if (Simple_Duplex[Aff_Mem]=="simplex"){
    //reception par la voie UHF et transmission en VHF
    if(digitalRead(SQL_UHF)==val_SQL_UHF){
      PTT_VHF_ON(); //activation PTT VHF - retransmission de la UHF sur la VHF
      compt=0;
      bip_antibavard=false;
      while (digitalRead(SQL_UHF)==val_SQL_UHF){
                   //================> detection blocage squelch pour sortir de la boucle, compteur anti-bavard
                    delay (200);
                    compt++;
                    if (compt>=(antibavard2*5)){break;}
                    if ((compt>=antibavard1*5)and (!bip_antibavard)){
                      antibavard_musique();
                    }  
        afficheur(); //affiche les données sur le LCD
          digitalWrite(Led_SQL_UHF,digitalRead(SQL_UHF));
          digitalWrite(Led_SQL_VHF,digitalRead(SQL_VHF));
      }
      digitalWrite(PTT_VHF, LOW);
      digitalWrite(Led_PTT_VHF, HIGH);
      K(); //envoi du K sur le relais
    }
    //reception par la voie VHF
    if (digitalRead(SQL_VHF)==val_SQL_VHF){
      digitalWrite(BF_UHF_in_4066, LOW); //desactive la BF de la voix UHF

      compt=0;
      bip_antibavard=false;
      while (digitalRead(SQL_VHF)==val_SQL_VHF){
                    //================> detection blocage squelch pour sortir de la boucle, compteur anti-bavard
                    delay (200);
                    compt++;
                    if (compt>=(antibavard2*5)){break;}
                    if ((compt>=(antibavard1*5))and (!bip_antibavard)){
                      antibavard_musique();
                    }  
        afficheur(); //affiche les données sur le LCD
        digitalWrite(Led_SQL_UHF,digitalRead(SQL_UHF));
        digitalWrite(Led_SQL_VHF,digitalRead(SQL_VHF));
      }
      digitalWrite(BF_UHF_in_4066, HIGH); // Autorise la voix UHF avant le KVHF et le K
      KVHF(); //envoi d'un bip sur la voie VHF
      K(); //envoi du K sur le relais
      //digitalWrite(BF_UHF_in_4066, HIGH); // Autorise la voix UHF
    }

  }
  //======================= Fonctionnement avec une frequence Relais en VHF =======================================
 if (Simple_Duplex[Aff_Mem]=="relais"){
  if ((digitalRead(SQL_VHF)==val_SQL_VHF)or(digitalRead(SQL_UHF)==val_SQL_UHF)){
      
      compt=0;
      bip_antibavard=false;

      if(digitalRead(SQL_UHF)==val_SQL_UHF){
      PTT_VHF_ON(); //activation PTT VHF - retransmission de la UHF sur la VHF
      while (digitalRead(SQL_UHF)==val_SQL_UHF){
                   //================> detection blocage squelch pour sortir de la boucle, compteur anti-bavard
                    delay (200);
                    compt++;
					
                    if (compt>=(antibavard2*5)){break;}
                    if ((compt>=antibavard1*5)and (!bip_antibavard)){
                      antibavard_musique();
                    }  
        afficheur(); //affiche les données sur le LCD
          digitalWrite(Led_SQL_UHF,digitalRead(SQL_UHF));
          digitalWrite(Led_SQL_VHF,digitalRead(SQL_VHF));
      }
      digitalWrite(PTT_VHF, LOW);
      digitalWrite(Led_PTT_VHF, HIGH);
      K(); //envoi du K sur le relais
      relais_ok=false;
    }
    if(digitalRead(SQL_VHF)==val_SQL_VHF){
      relais_ok=true;
      TimeOutQSO=millis();
    }
  }else{
    if(relais_ok==true){
    delay(500); //confirmation que les squelchs sont retombés
    if ((digitalRead(SQL_VHF)!=val_SQL_VHF)and(digitalRead(SQL_UHF)!=val_SQL_UHF)){
    
      relais_ok=false;
      K(); //envoi du K sur le relais
    }}
  }


  }
  
}
  
  analyse_DTMF(); // analyse des code DTMF
  afficheur();//affiche les données sur le LCD


}


// démmarrage du relais
void Start_Relais(){
  detachInterrupt(0); // arret des interruptions pour le déclenchement du relais
  detachInterrupt(1);
  relais_en_service=true;
  TimeOutQSOStart=true;
  etat_relais=false;  // remise à zero de la demande de mise en service du relais
  BaliseTimerStart=false; //arret de la balise
  timeout_vhfStart=false;

   digitalWrite(BF_APRS_in_4066, LOW); // arret APRS sur Voie VHF
   digitalWrite(BF_APRS_out_4066, LOW);
   
   if (Aff_Mem==1){
     digitalWrite(Mem_VHF,HIGH); // position sur la frequence par defaut
     delay (200);
     digitalWrite(Mem_VHF,LOW);
     delay (200);
     Aff_Mem = Mem_Start; // se remet sur la frequence par defaut si on etait sur l'APRS avant sinon on reste sur l'ancienne frequence VHF
   }
   //Aff_Mem = 15;
   relais_ok=false;
   digitalWrite(BF_VHF_out_4066, HIGH); //autorise la BF de la voie VHF
   digitalWrite(BF_VHF_in_4066, HIGH);
  indicatif(); // envoi de l'indicatif
  K();   //envoi du K sur le relais
}

// arret de l'emission du relais, fin de QSO
void StopRelais()
{
  relais_en_service=false;
  TimeOutQSOStart=false;
  envoiCW("73"); // envoi en CW 73
  delay(500); 
  digitalWrite(PTT_UHF, LOW); // arret emission de la voie UHF
  digitalWrite(PTT_VHF, LOW);  // arret emission de la voie VHF
  digitalWrite(Led_PTT_UHF, HIGH); // arret Led emission de la voie UHF
  digitalWrite(Led_PTT_VHF, HIGH);  // arret Led emission de la voie VHF
  BaliseTimerStart=true;  // remise en service de la balise
  BaliseTimer=millis();
  AutoriseInt(); // autorise les interruptions pour le déclenchement du relais
  timeout_vhfStart=true; // RAZ frequence VHF
}
void InitVHF()
{
   timeout_vhfStart=false; // arret RAZ frequence VHF
   digitalWrite(Mem_VHF,HIGH); // position sur la frequence par defaut
   delay (200);
   digitalWrite(Mem_VHF,LOW);
   delay (200);
   // positionne sur la frequence APRS
   digitalWrite(BF_VHF_out_4066, LOW); //coupe la BF de la voie VHF
   digitalWrite(BF_VHF_in_4066, LOW);
   digitalWrite(BF_APRS_in_4066, HIGH); // APRS sur Voie VHF
   digitalWrite(BF_APRS_out_4066, HIGH);
   compt_mem =Mem_Start-2;
     for (int i=0; i <= abs(compt_mem); i++){ 
       digitalWrite(Mem_Down,HIGH); // Appui sur la touche DOWN
       delay (200);
       digitalWrite(Mem_Down,LOW);  
        delay (200);   
     }
  Aff_Mem = 1;
}
// convertion du texte en CW
void envoiCW(String textecw)
{

  int boucle=1;
  while ((boucle <= textecw.length()) and (!etat_relais)){ // on fait une lecture caractere par caractere de tout le texte. on arrete l'envoi de la CW si il y a une demande de mise en service du relais
  lettre=textecw.substring(boucle-1,boucle);  // caratere de debut,caractere de fin 0,1 puis 1,2 puis 2,3 etc....
  lettrecw=txttocodecw(lettre); // conversion d'un caractere en CW
  GenCW(lettrecw); // generation des tonailtés en fonction des - et des .
  boucle++;
  }  
}

// envoi de la balise courte et de la balise longue
void EnvoiBalise()
{
  if (!Int_Balise){
    detachInterrupt(0); // arret des interruptions pour le déclenchement du relais
    detachInterrupt(1); // 
  }
  PTT_UHF_ON(); 
  delay(500);
  if (compt_balise<nb_balise){ //comptage des balises courtes avant l'envoi de la longue
  envoiCW(balise_relais_court); //balise courte
  }else{
  envoiCW(balise_relais_long); //balise longue
  }
  compt_balise++;
  if(compt_balise>nb_balise){
    compt_balise=0; // si on a envoyé les balises courte et la balise longue, on remet le compteur à zéro
  }
  if (!etat_relais) // si la mise en service du relais est demandée, on supprime la tempo
  {
   delay(500); 
  }
  digitalWrite(PTT_UHF, LOW);
  digitalWrite(Led_PTT_UHF, HIGH);
 if (!Int_Balise){ 
  AutoriseInt(); // autorise les interruptions pour le déclenchement du relais
 }
}

// envoi de l'indicatif du relais
void indicatif()
{
  PTT_UHF_ON(); // activation de la voie UHF
  delay(500);
  afficheur(); //affiche les données sur le LCD
  envoiCW(indicatif_relais); // envoi de l'indication en CW
}

// envoi du K sur l'UHF
void K()
{
  if (compt>=(antibavard2*5)){ //si trop bavard, arret du relais
    envoiCW("73");
    delay(200); 
    digitalWrite(PTT_UHF, LOW); // arret emission de la voie UHF
    digitalWrite(Led_PTT_UHF, HIGH); // arret Led emission de la voie UHF
    delay(10000); //desactive le relais pendant 10 secondes
    BaliseTimerStart=true;  // remise en service de la balise
    BaliseTimer=millis();
    AutoriseInt(); // autorise les interruptions pour le déclenchement du relais
  }else{
  delay(100);

    lettrecw=txttocodecw("K");
    if (compteur_DTMF<4) {compteur_DTMF=0;}
    GenCW(lettrecw); // envoi du K sur la voie UHF

  TimeOutQSO=millis();
  } 
compt=0;
}
// envoi du bip sur la voie VHF
void KVHF()
{
  if (BaliseCW){  
    delay(300);

    PTT_VHF_ON(); // mise en service de la voie VHF
    Bip(200); // envoi du Bip
  }
    delay(100);
    digitalWrite(PTT_VHF, LOW); // arret emission de la voie VHF
    digitalWrite(Led_PTT_VHF, HIGH); // arret Led emission de la voie VHF

}

// envoi des bips antibavard
void antibavard_musique()
{
  Bip(50); // envoi du Bip
  delay(1000);
  Bip(50); // envoi du Bip
  delay(1000);
  Bip(50); // envoi du Bip
  delay(1000);
  Bip(50); // envoi du Bip
  delay(1000);
  Bip(500); // envoi du Bip
bip_antibavard=true;
}

// affichage des variables du programme
void afficheur(){
if (LCD==true){
  etat_PTT_UHF="Off";
  etat_PTT_VHF="Off";
  if (digitalRead(PTT_UHF)){
    etat_PTT_UHF="On ";
  }
  lcd_A.setCursor(9,1);
  lcd_A.print(etat_PTT_UHF);
  if (digitalRead(PTT_VHF)){
    etat_PTT_VHF="On ";
  }  
  lcd_B.setCursor(9,0);
  lcd_B.print(etat_PTT_VHF);  
  etat_SQL_UHF="Off";
  etat_SQL_VHF="Off";
  if (digitalRead(SQL_UHF)==val_SQL_UHF){
    etat_SQL_UHF="On ";
  }
  lcd_A.setCursor(17,1);
  lcd_A.print(etat_SQL_UHF);
  if (digitalRead(SQL_VHF)==val_SQL_VHF){
    etat_SQL_VHF="On ";
  } 
  lcd_B.setCursor(17,0);
  lcd_B.print(etat_SQL_VHF);
  
  etat_TONE_1750="1750Hz Off";
  if (digitalRead(TONE_1750)==val_TONE_1750){
    etat_TONE_1750="1750Hz On ";
  }
  if (digitalRead(TONE_SQL)){
    etat_TONE_1750="Squelch   ";
  }
  lcd_A.setCursor(12,0);
  lcd_A.print(etat_TONE_1750); 
  antibavardsec=antibavard1-compt/5;
  lcd_B.setCursor(12,1);
  if (antibavardsec<100){
    lcd_B.print("0");
  }
  if (antibavardsec<10){
    lcd_B.print("0");
  }  
  lcd_B.print(antibavardsec);  
  lcd_B.print("/"); 
 antibavardsec=antibavard2-compt/5;
   if (antibavardsec<100){
    lcd_B.print("0");
  }
  if (antibavardsec<10){
    lcd_B.print("0");
  }  
  lcd_B.print(antibavardsec);  
  lcd_B.print(" sec"); 
  
  lcd_A.setCursor(24,0);
  lcd_A.print("V:");
  lcd_A.print(int((millis()-timeout_vhf)/1000));
  lcd_A.print(" S:");
  lcd_A.print(int((millis()-TimeOutQSO)/1000));
  lcd_A.print(" B:");
  lcd_A.print(int((millis()-BaliseTimer)/1000));
  lcd_A.print("  ");
  //lcd_A.print("Interruption:");
  //if (etat_relais){
  //  lcd_A.print("ON ");
  //}else{
  //  lcd_A.print("OFF");
  //}
  lcd_A.setCursor(24,1);
  if (compt_balise<nb_balise){
  lcd_A.print("Balise Courte ");
  lcd_A.print(compt_balise+1);
  }else{
  lcd_A.print("Balise Longue   ");
  }

 

  lcd_B.setCursor(24,0);
  lcd_B.print("DTMF: ");
  lcd_B.print(compteur_DTMF);
  lcd_B.print(" -> ");
  if (compteur_DTMF){
  for (int i=0; i <= compteur_DTMF-1; i++){ 
  lcd_B.print(code_DTMF[i]);
  }}else{
    lcd_B.print("     ");
  }
  lcd_B.setCursor(24,1);
  lcd_B.print("CW: ");
  if (BaliseCW){
  lcd_B.print("On " );
  }else{
  lcd_B.print("Off");
  }
  lcd_B.print("  Mem:");
  lcd_B.print(Aff_Mem);
  lcd_B.print(" ");
}
}
// translation du caractere en CW
String txttocodecw(String caractere){
String codecw="";

if (caractere=="A"){codecw = ".-";}     //A
if (caractere=="B"){codecw = "-...";}   //B
if (caractere=="C"){codecw = "-.-.";}   //C
if (caractere=="D"){codecw = "-..";}   //D
if (caractere=="E"){codecw = ".";}     //E
if (caractere=="F"){codecw = "..-.";}   //F
if (caractere=="G"){codecw = "--.";}    //G
if (caractere=="H"){codecw = "....";}   //H
if (caractere=="I"){codecw = "..";}     //I
if (caractere=="J"){codecw = ".---";}   //J
if (caractere=="K"){codecw = "-.-";}   //K
if (caractere=="L"){codecw = ".-..";}  //L
if (caractere=="M"){codecw = "--";}    //M
if (caractere=="N"){codecw = "-.";}    //N
if (caractere=="O"){codecw = "---";}   //O
if (caractere=="P"){codecw = ".--.";}  //P
if (caractere=="Q"){codecw = "--.-";}  //Q
if (caractere=="R"){codecw = ".-.";}   //R
if (caractere=="S"){codecw = "...";}   //S
if (caractere=="T"){codecw = "-";}     //T
if (caractere=="U"){codecw = "..-";}   //U
if (caractere=="V"){codecw = "...-";}  //V
if (caractere=="W"){codecw = ".--";}   //W
if (caractere=="X"){codecw = "-..-";}  //X
if (caractere=="Y"){codecw = "-.--";}  //Y
if (caractere=="Z"){codecw = "--..";}  //Z
if (caractere=="0"){codecw = "-----";} //0
if (caractere=="1"){codecw = ".----";} //1
if (caractere=="2"){codecw = "..---";} //2
if (caractere=="3"){codecw = "...--";} //3
if (caractere=="4"){codecw = "....-";} //4
if (caractere=="5"){codecw = ".....";} //5
if (caractere=="6"){codecw = "-....";} //6
if (caractere=="7"){codecw = "--...";} //7
if (caractere=="8"){codecw = "---..";} //8
if (caractere=="9"){codecw = "----.";} //9
if (caractere=="."){codecw = ".-.-.-";} //.
if (caractere==","){codecw = "--..--";} //,
if (caractere=="?"){codecw = "..--..";} //?
if (caractere=="/"){codecw = "-..-.";} ///
if (caractere=="-"){codecw = "-....-";} //-
if (caractere=="="){codecw = "-...-";} //=
if (caractere=="+"){codecw = ".-.-.";} //+
if (caractere=="'"){codecw = ".----.";} ////
if (caractere=="@"){codecw = ".--.-.";} //@
if (caractere==" "){codecw = " ";} //

return codecw;
}

// generation des tonalités en fonctions des - ou des .
void GenCW (String lettrecw){
  if (BaliseCW){
  String son="";
  int boucle=1;
  while ((boucle <= lettrecw.length())and (!etat_relais)){ // on arrete la CW si la mise en service du relais est demandée
  son=lettrecw.substring(boucle-1,boucle);

    if (son=="-"){ // creation du son pour le -
    digitalWrite(SortieCW,HIGH);
    //delay(3*1200/vitesse);
    Buzzer(3*1200/vitesse); // generation de la BF
    digitalWrite(SortieCW,LOW);
    delay (1*1200/vitesse);
  }
    if (son=="."){ // creation du son pour le .
    digitalWrite(SortieCW,HIGH);
    //delay(1*1200/vitesse);
    Buzzer(1*1200/vitesse); // generation de la BF
    digitalWrite(SortieCW,LOW);
    delay (1*1200/vitesse);
  }
    if (son==" "){ // pause entre chaque lettre
    delay (4*1200/vitesse);
  }


 boucle++;
  }

  delay (2*1200/vitesse);

}}

// generation du signal BF pour la CW
void Buzzer(long tpsenms){
  int bouclebuzzer=tpsenms*1000/1250;
  while(bouclebuzzer){
 digitalWrite(SortieBuzzer, HIGH); /* active le port de sortie à l'état haut */
 /* delay(1); /* Attente une milli seconde */
 delayMicroseconds(625); 
 digitalWrite(SortieBuzzer, LOW); /* active le port de sortie à l'état bas */
 /* delay(1); /* Attente une milli seconde avant de recommencer */ 
 delayMicroseconds(625); 
 bouclebuzzer--;
  }
}

// generation du signal BF pour le Bip
void Bip(long tpsenms){
  int bouclebuzzer=tpsenms*1000/800;
  while(bouclebuzzer>0){
 digitalWrite(SortieBuzzer, HIGH); /* active le port de sortie à l'état haut */
 /* delay(1); /* Attente une milli seconde */
 delayMicroseconds(400); 
 digitalWrite(SortieBuzzer, LOW); /* active le port de sortie à l'état bas */
 /* delay(1); /* Attente une milli seconde avant de recommencer */ 
 delayMicroseconds(400); 
 bouclebuzzer--;
  }
}
void PTT_UHF_ON()
{
if (PTT_UHF_ok){
  digitalWrite(PTT_UHF, HIGH);
  digitalWrite(Led_PTT_UHF, LOW);
  }
}

void PTT_VHF_ON()
{
if (PTT_VHF_ok){
  digitalWrite(PTT_VHF, HIGH);
  digitalWrite(Led_PTT_VHF, LOW);
  }
}

// programme traitement des codes DTMF pour les changement de frequences de la voie VHF
void analyse_DTMF()
{
 erreur_DTMF=false; 

 if (compteur_DTMF > 4){erreur_DTMF = true;}
 //if (compteur_DTMF == 5 and code_DTMF[4]!="#" ){erreur_DTMF = true;}
 
 if (compteur_DTMF == 4 and !erreur_DTMF){
 Freq_DTMF=code_DTMF[0]+code_DTMF[1]+code_DTMF[2]+code_DTMF[3];
 //verification du code si correspond à une memoire de la voie VHF
 compt_mem=0;
 while (compt_mem<60){
 if(Memoire_VHF[compt_mem]==Freq_DTMF) {break;}
 compt_mem++;
 }
  if (compt_mem==60){erreur_DTMF = true; //pas de correspondance avec les memoires programmees
  }else{
  if (compt_mem==50){PTT_VHF_ok = false;}
  if (compt_mem==51){PTT_UHF_ok = false;}
  if (compt_mem==52){PTT_VHF_ok = true;}
  if (compt_mem==53){PTT_UHF_ok = true;}
  if (compt_mem==54){BaliseCW = true;}
  if (compt_mem==55){BaliseCW = false;}
  if (compt_mem==56){valide_DTMF = true;}
  if (compt_mem==57){valide_DTMF = false;}
    if (valide_DTMF){  // autorise le changement de frequence si on autorise la dtmf
   if (compt_mem<50) {
   digitalWrite(BF_VHF_in_4066, LOW);
   digitalWrite(Mem_VHF,HIGH); // position sur la frequence par defaut
   delay (200);
   digitalWrite(Mem_VHF,LOW);
   delay (200);
   Aff_Mem=compt_mem;
   compt_mem=compt_mem-Mem_Start;
   
   if (compt_mem>0){
     for (int i=1; i <= compt_mem; i++){ 
       digitalWrite(Mem_Up,HIGH); // Appui sur la touche UP
       delay (200);
       digitalWrite(Mem_Up,LOW);  
        delay (200);   
     }
   }
   if (compt_mem<0){
     for (int i=1; i <= abs(compt_mem); i++){ 
       digitalWrite(Mem_Down,HIGH); // Appui sur la touche DOWN
       delay (200);
       digitalWrite(Mem_Down,LOW);  
        delay (200);   
     }
   } 
   digitalWrite(BF_VHF_in_4066, HIGH);
   }
   
     if(!relais_en_service){PTT_UHF_ON();} // activation de la voie UHF
     PTT_VHF_ON(); // activation de la voie VHF
     delay(100);
     etat_relais=false;
     envoiCW("OK");
     digitalWrite(PTT_VHF, LOW); // arret emission de la voie VHF   
     digitalWrite(Led_PTT_VHF, HIGH);
     if(!relais_en_service){
       digitalWrite(PTT_UHF, LOW);
       digitalWrite(Led_PTT_UHF, HIGH);
       }
     compteur_DTMF=0;
 
  
 }}
}
 if (erreur_DTMF){
   delay(500);
   if(!relais_en_service){PTT_UHF_ON();} // activation de la voie UHF
   PTT_VHF_ON(); // activation de la voie VHF
   delay(500);
   etat_relais=false;
   envoiCW("HI");
   digitalWrite(PTT_VHF, LOW); // arret emission de la voie VHF
   digitalWrite(Led_PTT_VHF, HIGH); // arret Led emission de la voie VHF
   if(!relais_en_service){
     digitalWrite(PTT_UHF, LOW);
     digitalWrite(Led_PTT_UHF, HIGH);
     }
   compteur_DTMF=0;
 }

}



// interruption si squelch de la voie VHF
void int_SQL_VHF()
{
  if (Aff_Mem!=1){
    etat_relais=true; // demande de mise service du relais
  }
}

// interruption si squelch de la voie UHF
void int_SQL_UHF()
{
  etat_relais=true; // demande de mise service du relais
}

void decode_DTMF()
{
  val_dtmf=digitalRead(DTMF_Q1)+digitalRead(DTMF_Q2)*2+digitalRead(DTMF_Q3)*4+digitalRead(DTMF_Q4)*8;
  if (val_dtmf<10){code_DTMF[compteur_DTMF]=String(val_dtmf);}
  if (val_dtmf==10){code_DTMF[compteur_DTMF]="0";}
  if (val_dtmf==11){code_DTMF[compteur_DTMF]="*";}
  if (val_dtmf==12){code_DTMF[compteur_DTMF]="#";}
  if (val_dtmf==13){code_DTMF[compteur_DTMF]="A";}
  if (val_dtmf==14){code_DTMF[compteur_DTMF]="B";}
  if (val_dtmf==15){code_DTMF[compteur_DTMF]="C";}
  if (val_dtmf==0){code_DTMF[compteur_DTMF]="D";}
  compteur_DTMF++;
  if (compteur_DTMF>5){compteur_DTMF=5;}
}



void AutoriseInt(){
   // desactivation du declenchement par la voix VHF puisque l'utilise en APRS

     if (val_SQL_VHF == false)// type d'interruption en focntion du squelch si on a une masse ou un + lorsque l'on a une présence porteuse
     {
     attachInterrupt(0, int_SQL_VHF, FALLING); // Interruption sur Front descendant
     }else{
     attachInterrupt(0, int_SQL_VHF, RISING); // Interruption sur Front montant
     }
   
   if (val_SQL_UHF == false)
   {
   attachInterrupt(1, int_SQL_UHF, FALLING); // Interruption sur Front des descendant
   }else{
   attachInterrupt(1, int_SQL_UHF, RISING); // Interruption sur Front montant
   } 
   
   attachInterrupt(2, decode_DTMF, RISING); // Interruption sur Front montant pour le decodage DTMF
}



